-- Menu editing
-- Author: Harpet
-- screen 480 x 272

white = Color.new(255,255,255)
blue = Color.new(0,0,255)
black = Color.new(0,0,0) 
green = Color.new(0, 255, 0)
red = Color.new(255, 0, 0)
red2 = Color.new(155, 0, 0)
yellow = Color.new(255, 255, 0)
yellow2 = Color.new(155, 155, 0)
grey = Color.new(52,52,52)
grey2 = Color.new(152,152,152)

kop=1 					-- start header menu
regel=1					-- start of row menu
telkop=3
pi=180/3.14159265
				-- number of menu headers
Date = os.date ("!*t") 			-- get current date

file = io.open("data/latlon.txt","r")	-- read the latitude longitude from file
	nb = file:read("*l") * 1
	ol = file:read("*l") * 1
file:close() 

centerx = 180
centerx2 = -180
centery = 0
centery2 = 180
diepte = 2
diepte2 = 2
step = 10

star   = {}
bounds = {}
lines  = {}
cname  = {}
messier = {}
planetra = {}
planetde = {}
planetna = {}

file = io.open("data/planets.txt","r")	
	maxplan= file:read("*l") * 1
file:close() 

for x = 1,maxplan do
	table.insert(planetra,1)
	table.insert(planetde,1)
	table.insert(planetna,1)
end

-- menu variables
startmenu = 0
Menu = { }
Menu[1] = { aantal = 4, a = "System", b = "Info", c = "Position", d = "Date+Time", e = "Exit"}
Menu[2] = { aantal = 3, a = "Catalog", b = "Star", c = "Constellation", d = "Messier"}
Menu[3] = { aantal = 2, a = "Graphics", b = "StarChart", c = "SkyChart"}

selector = { image = Image.createEmpty(80,8), x = 0,y = 0 }
selector.image:clear(blue)



--- general functions

function menu()
	screen:clear()
	screen:print(100,135,"Please set the correct Position and",red)
	screen:print(100,145,"   Date+Time before calculation",red)
	screen:blit(kop*80-70,regel*8,selector.image)	
	for a=1,telkop do        
        	screen:blit(a*80-70,0,selector.image) 
		screen:print(a*80-70,0,Menu[a].a,white)
        	if a==kop then
			if Menu[a].aantal > 0 then
	     			screen:print(a*80-70,8,Menu[a].b,yellow)	
	  		end
			if Menu[a].aantal >1  then
	     			screen:print(a*80-70,16,Menu[a].c,yellow)	
	  		end
			if Menu[a].aantal >2  then
	     			screen:print(a*80-70,24,Menu[a].d,yellow)	
			end
			if Menu[a].aantal >3  then
	     			screen:print(a*80-70,32,Menu[a].e,yellow)	
			end
			if Menu[a].aantal >4  then
	     			screen:print(a*80-70,40,Menu[a].f,yellow)	
			end
			if Menu[a].aantal >5  then
	     			screen:print(a*80-70,48,Menu[a].g,yellow)	
			end
			if Menu[a].aantal >6  then
	     			screen:print(a*80-70,56,Menu[a].h,yellow)	
			end
			if Menu[a].aantal >7  then
	     			screen:print(a*80-70,64,Menu[a].i,yellow)	
			end
			if Menu[a].aantal >8  then
	     			screen:print(a*80-70,72,Menu[a].j,yellow)	
			end
			if Menu[a].aantal >9  then
	     			screen:print(a*80-70,80,Menu[a].k,yellow)	
			end
			if Menu[a].aantal >10  then
	     			screen:print(a*80-70,88,Menu[a].l,yellow)	
			end		
			if Menu[a].aantal >11  then
	     			screen:print(a*80-70,96,Menu[a].m,yellow)	
			end		
					
		end
	end	
end

function drawcircle(target, ux, uy, crad, ccolor)
	degree = 0
	while degree < (6.4) do
		target:pixel((math.floor(crad * math.cos(degree)))+ux, (math.floor(crad * math.sin(degree))) +uy, ccolor)
		degree = degree + 0.005
	end
end 

function calcjd()	
	dd=da + hh/24 + mi / (24 * 60)
	if mm < 3 then yy=yy-1 mm=mm+12 end
	a=math.floor(yy / 100)
	b= 2 - a + math.floor(a / 4)
	if (yy + mm / 100 + dd / 10000) < 1582.1015 then b=0 end
	if yy > 0 then jd=math.floor(365.25 * yy)       + math.floor(30.6001 * (mm+1)) + dd + 1720994.5 + b end
	if yy < 0 then jd=math.floor(365.25 * yy - .75) + math.floor(30.6001 * (mm+1)) + dd + 1720994.5 + b end
end

function calccd()
	jd = jd + .5
	z = math.floor(jd)
	f = jd - math.floor(jd)
	al = math.floor(( z - 1867216.25) / 36524.25)
	a = z + 1 + al - math.floor(al / 4)
	if z < 2299161 then a = z end
	b = a + 1524
	c = math.floor((b - 122.1) / 365.25)
	d = math.floor(365.25 * c)
	e = math.floor((b - d) / 30.6001)
	dd = b - d - math.floor(30.6001 * e) + f
	mm = e - 1
	if e > 13.5 then mm = e - 13 end
	yy = c - 4716
	if mm < 2.5 then yy = c - 4715 end
	hh = (dd - math.floor(dd)) * 24
	mi = (hh - math.floor(hh)) * 60
	jd = jd - .5
	cd = string.format("%04d-%02d-%02d %02d:%02d",yy,mm,dd,hh,mi)
end

function calcstg()
	t=(jd - 2415020) / 36525		
	hhh = .276919398 + 100.0021359 * t + .000001075 * t^2
	hhh = hhh + hh / 24 + mi / 1440
	hhh = (hhh - math.floor(hhh)) * 24
	hhh = hhh - math.floor(ol/15)
	if hhh > 24 then hhh = hhh - 24 end
	if hhh < 0 then  hhh = hhh + 24 end	
	td = hhh
	mi = (hhh - math.floor(hhh)) * 60
	se = (mi - math.floor(mi)) * 60
end

--- menu functions

function credits()
	back = Image.load("pics/zonnestelsel.png") 
	back2 = Image.load("pics/ster.png") 
	back3 = Image.load("pics/messier.png") 	
	back4 = Image.load("pics/zon.png") 
	back5 = Image.load("pics/maan.png") 
	back6 = Image.load("pics/planeet.png") 
	back7 = Image.load("pics/plan.png") 
		screen:clear()
		screen:blit(0,25, back)
		screen:print(200,120,"    SkyChart v 2.0",white)
		screen:print(200,130,"Created by Harpet 2007",white)
		screen:print(200,140,"       E-Mail",white)
		screen:print(200,150,"  harpetgroup@home.nl ",white)
		screen:print(200,180,"  Press (O) to return",red)
		screen.waitVblankStart()
		screen.flip()
	while not pad:circle() do
		pad = Controls.read()
	end
end
function nbol()
	save = 0
	file = io.open("data/position.txt","r")
		maxtel= file:read("*l")
		maxtel = maxtel * 1
		tel = 1	
		coun= file:read("*l")
		city= file:read("*l")
		vnb= file:read("*l")
		vol= file:read("*l")
		vnb = math.floor(vnb * 100) / 100 
		vol = math.floor(vol * 100) / 100
	
	while not pad:circle() do
		pad = Controls.read()
		screen:clear()
		screen:print(100,80,"Database city locations",red)
		screen:print(100,90,"Country = "..coun,white)
		screen:print(100,100,"City    = "..city,white)
		screen:print(100,110,"Lat = "..vnb.." Lon = "..vol,white)
		screen:print(100,140,"Position for calculation",red)
		screen:print(100,150,"Lattitude  North = " .. nb,white)
		screen:print(100,160,"Longitude  West  = " .. ol,white)
		screen:print(150,200,"(O) = Back (Square) = Save",red)
		screen:print(150,210,"   (Down) = Next City",red)
		
		if pad:down() and tel < maxtel then
			coun= file:read("*l")
			city= file:read("*l")
			vnb= file:read("*l")
			vol= file:read("*l")
			vnb = math.floor(vnb * 100) / 100 
			vol = math.floor(vol * 100) / 100	
			tel = tel + 1
			for a=1,50000 do end	-- slow down menu
		end					
		screen.waitVblankStart()
		screen.flip()

		if pad:square() then
			nb = vnb
			ol = vol
			save = 1
		for a=1,50000 do end	-- slow down menu
		end
		
	end
	file:close() 
	if save == 1 then
		file = io.open("data/latlon.txt","w")
		file:write(nb)
		file:write("\n")
		file:write(ol)
		file:close() 
	end

end

function datum()	
	a = 1
	while not pad:circle() do
		pad = Controls.read()
		screen:clear()
		screen:blit(100,a*10+100,selector.image)
		screen:print(100,100,"Please adjust the Date/Time",red)			
		screen:print(100,110,"Year  = " .. Date.year,white)
		screen:print(100,120,"Month = " .. Date.month,white)
		screen:print(100,130,"Day   = " .. Date.day,white)
		screen:print(100,140,"Hour  = " .. Date.hour,white)
		screen:print(100,150,"Minute= " .. Date.min,white)
		screen:print(100,170,"(O) = Back   (Square) = Reset",red)
		
		if pad:right() and a == 1 then Date.year=Date.year+1 end	
		if pad:right() and a == 2 then Date.month=Date.month+1 end
		if pad:right() and a == 3 then Date.day=Date.day+1 end
		if pad:right() and a == 4 then Date.hour=Date.hour+1 end
		if pad:right() and a == 5 then Date.min=Date.min+1 end
		if pad:left() and a == 1 then Date.year=Date.year-1 end	
		if pad:left() and a == 2 then Date.month=Date.month-1 end
		if pad:left() and a == 3 then Date.day=Date.day-1 end
		if pad:left() and a == 4 then Date.hour=Date.hour-1 end
		if pad:left() and a == 5 then Date.min=Date.min-1 end
		if pad:down() then a=a+1 end
		if pad:up() then a=a-1 end
		if pad:square() then Date = os.date ("!*t") end
		if a>5 then a=5 end
		if a<1 then a=1 end
		if Date.month > 12 then Date.month = 12 end
		if Date.month <1 then Date.month = 1 end
		if Date.day > 31 then Date.day = 31 end
		if Date.day < 1 then Date.day = 1 end
		if Date.hour > 23 then Date.hour = 23 end
		if Date.hour < 0 then Date.hour = 0 end
		if Date.min > 59 then Date.min = 59 end
		if Date.min < 0 then Date.min = 0 end
		screen.waitVblankStart()
		screen.flip()
		for a=1,50000 do end	-- slow down menu
	end	
end

function starv()
	tel=1 maxtel=218
	while not pad:circle() do
		pad = Controls.read()
		screen:clear()
		ra = star[tel].x
		de = star[tel].y
		r1 = math.floor(ra / 15)
		r2 = math.floor(((ra/15) - r1) * 60)
		d1 = math.floor(de)
		d2 = math.floor((de - d1) * 60)
		
		screen:print(140,80,"Visible Star",red)
		screen:print(140,90,"Name            = "..star[tel].m,white)
		screen:print(140,100,"Right Ascension = "..r1.." Hr "..r2.." Mn",white)
		screen:print(140,110,"Declination     = "..d1.." Dg "..d2.." Mn",white)
		screen:print(140,120,"Magnitude       = "..star[tel].z,white)

		screen:print(150,200,"(O) = Back (Square) = View",red)
		screen:print(150,210,"     (Up)  (Down) ",red)
		
		if pad:down() and tel < maxtel then	
			tel = tel + 1
			for a=1,20000 do end	-- slow down menu
		end	
		if pad:up() and tel > 1 then	
			tel = tel - 1
			for a=1,20000 do end	-- slow down menu
		end
		if pad:square() then
			centerx = ra
			centery = de
			diepte = 6
			starchart()
		for a=1,50000 do end	-- slow down menu
		end
				
		screen.waitVblankStart()
		screen.flip()	
	end	
end

function constelationv()
	tel=1 maxtel=89
	while not pad:circle() do
		pad = Controls.read()
		screen:clear()
		ra = cname[tel].x
		de = cname[tel].y
		r1 = math.floor(ra / 15)
		r2 = math.floor(((ra/15) - r1) * 60)
		d1 = math.floor(de)
		d2 = math.floor((de - d1) * 60)
		
		screen:print(140,80,"Constellation",red)
		screen:print(140,90,"Name            = "..cname[tel].z,white)
		screen:print(140,100,"Right Ascension = "..r1.." Hr "..r2.." Mn",white)
		screen:print(140,110,"Declination     = "..d1.." Dg "..d2.." Mn",white)
	

		screen:print(150,200,"(O) = Back (Square) = View",red)
		screen:print(150,210,"     (Up)  (Down) ",red)
		
		if pad:down() and tel < maxtel then	
			tel = tel + 1
			for a=1,20000 do end	-- slow down menu
		end	
		if pad:up() and tel > 1 then	
			tel = tel - 1
			for a=1,20000 do end	-- slow down menu
		end
		if pad:square() then
			centerx = ra
			centery = de
			diepte = 4
			starchart()
		for a=1,50000 do end	-- slow down menu
		end
				
		screen.waitVblankStart()
		screen.flip()		
	end	
end

function messierv()
	tel=1 maxtel=110
	while not pad:circle() do
		pad = Controls.read()
		screen:clear()
		ra = messier[tel].x
		de = messier[tel].y
		r1 = math.floor(ra / 15)
		r2 = math.floor(((ra/15) - r1) * 60)
		d1 = math.floor(de)
		d2 = math.floor((de - d1) * 60)
		
		screen:print(140,80,"Messier Database",red)
		screen:print(140,90,"Catalog Number  = "..messier[tel].m,white)
		screen:print(140,100,"Right Ascension = "..r1.." Hr "..r2.." Mn",white)
		screen:print(140,110,"Declination     = "..d1.." Dg "..d2.." Mn",white)
		screen:print(140,120,"Magnitude       = "..messier[tel].z,white)

		screen:print(150,200,"(O) = Back (Square) = View",red)
		screen:print(150,210,"     (Up)  (Down) ",red)
		
		if pad:down() and tel < maxtel then	
			tel = tel + 1
			for a=1,20000 do end	-- slow down menu
		end	
		if pad:up() and tel > 1 then	
			tel = tel - 1
			for a=1,20000 do end	-- slow down menu
		end
		if pad:square() then
			centerx = ra
			centery = de
			diepte = 6
			starchart()
		for a=1,50000 do end	-- slow down menu
		end
				
		screen.waitVblankStart()
		screen.flip()
	end	
end

function starchart()
	plot()
	while not pad:circle() do
		pad = Controls.read()
		if pad:left() then  centerx = centerx + step check() plot() end
		if pad:right() then centerx = centerx - step check() plot() end
		if pad:up() then  centery = centery + step check() plot() end
		if pad:down() then centery = centery - step check() plot() end
		if pad:l() then diepte = diepte + 1 check() plot() end
		if pad:r() then diepte = diepte - 1 check() plot()  end		
	end
end

function skychart()
			
		yy=Date.year
		mm=Date.month
		da=Date.day
		hh=Date.hour
		mi=Date.min
		calcjd()
		dofile("./calc.lua")
		calccd()
		calcstg()
		td = td * 15 + ol
		p1 = 1 / pi
		sb = math.sin(nb * p1)
		cb = math.cos(nb * p1)
		plot2()
	while not pad:circle() do
		pad = Controls.read()
		if pad:l() and diepte2 <= 7 then diepte2 = diepte2 + 1 plot2() end
		if pad:r() and diepte2 >= 2 then diepte2 = diepte2 - 1 plot2()  end
		if pad:left() then  centerx2 = centerx2 + 10 plot2() end
		if pad:right() then centerx2 = centerx2 - 10 plot2() end
		if pad:up() then  centery2 = centery2 - 10 plot2() end
		if pad:down() then centery2 = centery2 + 10 plot2() end
	end
end

function check()
	if centerx > 360 then centerx = 360 end
	if centerx < 0 then centerx = 0 end
	if centery > 90 then centery = 90 end
	if centery < -90 then centery = -90 end
	if diepte < 2 then diepte = 2 end
	if diepte == 3 then step = 10 end
	if diepte == 4 then step = 5 end
	if diepte > 5 then step = 1 end
end

function plot()
		screen:clear()
		screen:print(1,1,"Zoom in (L)",white)
		screen:print(380,1,"Zoom Out (R)",white)
		screen:print(200,1,"Depth = "..diepte,red)
		screen:print(230,250,math.floor(centerx/15).."Hr",white)
		screen:print(10,136,math.floor(centery).." Dg",white)	
		r1 = (centerx + 180/diepte) / 15
		if r1 > 24 then r1 = r1 - 24 end
		r2 = (centerx - 180/diepte) / 15
		if r2 < 0 then r2 = r2 + 24 end
		d1 = (centery + 90/diepte)
		if d1 > 90 then d1 = 90 - d1 end
		d2 = (centery - 90/diepte)
		if d2 < -90 then d2 = -90 - d2 end
		screen:print(50,250,math.floor(r1),white)
		screen:print(420,250,math.floor(r2),white)
		screen:print(10,46,math.floor(d1),white)
		screen:print(10,226,math.floor(d2),white)
		
		sra = 0 sde = 0
		era = 0 ede = 0	

-- boundaries of the constellations

		for x = 1,876 do	
			if bounds[x].x == 0 then sra = bounds[x].y sde = bounds[x].z end
			if bounds[x].x == 1 then
				era = bounds[x].y ede = bounds[x].z
				if bounds[x].y < (centerx + (180 / diepte)) and bounds[x].y > (centerx - (180 / diepte)) then
					if bounds[x].z < (centery + (90 / diepte)) and bounds[x].z > (centery - (90 / diepte)) then
						a1 = 230 -(-centerx      + sra) * diepte 
						a2 = 136 + (centery      - sde) * diepte
						a3 = 230 -(-centerx 	 + era) * diepte
						a4 = 136 + (centery      - ede) * diepte
						if a3 < 60 then  a3 = a1  a4 = a2 end
						if a3 > 420 then a3 = a1  a4 = a2 end
						if a4 < 46 then  a4 = a2  a3 = a1 end
						if a4 > 226 then a4 = a2  a3 = a1 end
						screen:drawLine(a1,a2,a3,a4,grey)
					end		
				end
			sra = era sde = ede
			end			
		end		

-- lines of the constellations

		for x = 1,646 do	
			if lines[x].x < (centerx + (180 / diepte)) and lines[x].x > (centerx - (180 / diepte)) then
				if lines[x].y < (centery + (90 / diepte)) and lines[x].y > (centery - (90 / diepte)) then
					a1 = 230 -(-centerx      + lines[x].x) * diepte 
					a2 = 136 + (centery      - lines[x].y) * diepte
					a3 = 230 -(-centerx 	 + lines[x].z) * diepte
					a4 = 136 + (centery      - lines[x].w) * diepte
					if a3 < 60 then  a3 = a1  a4 = a2 end
					if a3 > 420 then a3 = a1  a4 = a2 end
					if a4 < 46 then  a4 = a2  a3 = a1 end
					if a4 > 226 then a4 = a2  a3 = a1 end
					if math.abs(lines[x].x - lines[x].z) > 160 then a3=a1 a4=a2 end 
					if math.abs(lines[x].y - lines[x].w) > 50 then a3=a1 a4=a2 end 
					screen:drawLine(a1,a2,a3,a4,red2)
				end	
			end					
		end	

-- the names of the constellation

		if diepte > 2 then
			for x = 1,89 do	
				if cname[x].x < (centerx + (180 / diepte)) and cname[x].x > (centerx - (180 / diepte)) then
					if cname[x].y < (centery + (90 / diepte)) and cname[x].y > (centery - (90 / diepte)) then
						a1 = 230 -(-centerx      + cname[x].x) * diepte 
						a2 = 136 + (centery      - cname[x].y) * diepte
						screen:print(a1-20,a2,cname[x].z,white)
					end
				end					
			end	
		end
		
-- messier elements

		if diepte > 4 then
			for x = 1,110 do	
				if messier[x].x < (centerx + (180 / diepte)) and messier[x].x > (centerx - (180 / diepte)) then
					if messier[x].y < (centery + (90 / diepte)) and messier[x].y > (centery - (90 / diepte)) then
						a1 = 230 -(-centerx      + messier[x].x) * diepte 
						a2 = 136 + (centery      - messier[x].y) * diepte		
						screen:blit(a1,a2, back3)
						if diepte > 5 then screen:print(a1-10,a2+10,messier[x].m,green) end
					end
				end					
			end	
		end

-- names of stars
		if diepte > 2 then
			for x = 1,218 do	
				if star[x].x < (centerx + (180 / diepte)) and star[x].x > (centerx - (180 / diepte)) then
					if star[x].y < (centery + (90 / diepte)) and star[x].y > (centery - (90 / diepte)) then
						a1 = 230 -(-centerx      + star[x].x) * diepte 
						a2 = 136 + (centery      - star[x].y) * diepte
						screen:blit(a1,a2, back2)
						if diepte > 5 then screen:print(a1-10,a2+10,star[x].m,yellow2) end
					end
				end					
			end	
		end



		screen.waitVblankStart()
		screen:flip()
end

function plot2()
		screen:clear()
		screen:print(1,1,"Zoom in (L)",white)
		screen:print(380,1,"Zoom Out (R)",white)
		screen:print(200,1,"Depth = "..diepte2,red)
		screen:print(0,20,"Time = "..cd,white)
		screen:print(0,30,"Lat = "..nb,white)
		screen:print(0,40,"Lon = "..ol,white)



--lines of the constellations
						
		for tel = 1,646 do
			re = lines[tel].x
			de = lines[tel].y
			calc()
			r1 = x
			r2 = y
			re = lines[tel].z
			de = lines[tel].w
			calc()
			if y~=0 and x ~= 0 then
				if r1 ~= 0 and r2 ~= 0 then
					screen:drawLine(180+(r1+centerx2)*diepte2,180+(r2-centery2) * diepte2,180+(x+centerx2)*diepte2,180+(y-centery2) * diepte2,red2)
				end
			end
		end

-- the names of the constellation	
	
	if diepte2 >= 2 then
		for tel = 1,89 do
			re = cname[tel].x
			de = cname[tel].y
			calc()
 
			if y~=0 and x ~= 0 then
				screen:print(180+(x+centerx2)*diepte2,180+(y-centery2) * diepte2,cname[tel].z,grey2)
			end
		end
	end


-- messier elements	
	
	if diepte2 >= 3 then
		for tel = 1,110 do
			re = messier[tel].x
			de = messier[tel].y
			calc()

			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back3)
				screen:print(180+(x+centerx2)*diepte2-10,180+(y-centery2) * diepte2+10,messier[tel].m,green)
			end
		end
	end


-- Names of star	
	
	if diepte2 >= 1 then
		for tel = 1,218 do
			re = star[tel].x
			de = star[tel].y
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back2)
				if diepte2 >=4 then
					screen:print(180+(x+centerx2)*diepte2-10,180+(y-centery2) * diepte2+10,star[tel].m,yellow2)
				end
			end
		end
	end

	if diepte2 >= 1 then
		re=rasun
		de=desun
		calc()
		if y~=0 and x ~= 0 then
			screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back4)
			screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Sun",white)
		end
		re=ramoon
		de=demoon
		calc()
		if y~=0 and x ~= 0 then
			screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back5)
			screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Moon",white)
		end

		if diepte2 >= 2 then
			re=ramer
			de=demer
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Mercury",white)
			end
			re=raven
			de=deven
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Venus",white)
			end
			re=ramar
			de=demar
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Mars",white)
			end
			re=rajup
			de=dejup
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Jupiter",white)
			end
			re=rasat
			de=desat
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Saturn",white)
			end
			re=raura
			de=deura
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Uranus",white)
			end
			re=ranep
			de=denep
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Meptune",white)
			end
			re=raplu
			de=deplu
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back6)
				screen:print(180+(x+centerx2) * diepte2-10,180+(y-centery2) * diepte2+15,"Pluto",white)
			end
		end
	end

	if diepte2 >= 4 then
		for tel = 1,maxplan do
			re = planetra[tel]
			de = planetde[tel]
			calc()
			if y~=0 and x ~= 0 then
				screen:blit(180+(x+centerx2) * diepte2,180+(y-centery2) * diepte2,back7)
				screen:print(180+(x+centerx2)*diepte2-10,180+(y-centery2) * diepte2+10,planetna[tel],blue)
				
			end
		end
	end



		screen.waitVblankStart()
		screen:flip()
end

function calc()
	ppi = 3.1415927
	x=0 y=0
	de = de * p1
	sw = td - re - ol
	sw = (sw - math.floor(sw / 360) * 360) * p1
	h = sb * math.sin(de) + cb * math.cos(de) * math.cos(sw)
	h = math.atan(h / math.sqrt(1 - h * h))
	if h >= 0 then 	
		a = (math.sin(de) - sb * math.sin(h)) / (cb * math.cos(h))
		if math.abs(a) >= 1 then a = a * .9998 end
		a = ppi / 2 - math.atan(a / math.sqrt(1 - a * a))
		if sw < ppi then a = -a end
		r = 99 - h * 198 / ppi
		w = -a - ppi / 2
		x = math.floor(math.cos(w) * r * 1.1 + 159.5)
		y = math.floor(math.sin(w) * r * 2 + 199.5)
		x = (2 * x) * .58 + 45
		y = y * .58 + 20
		end
end


dofile("./bounds.lua")
dofile("./lines.lua")
dofile("./cname.lua")
dofile("./messier.lua")
dofile("./star.lua")


pad = Controls.read()
credits()
		
-- Main menu
while true do
	pad = Controls.read()

	if pad:right()  then
	   	kop=kop+1
		regel=1
	end
	if pad:left()  then
	   	kop=kop-1
		regel=1
	end
	if pad:down()  then
	   	regel=regel+1
	end
	if pad:up()  then
	   	regel=regel-1
	end

	if kop < 1 then 
		kop=1 
	end
	if kop > telkop then 
		kop=telkop	
	end
	if regel<1 then
		regel=1
	end
	if regel> Menu[kop].aantal then
		regel=Menu[kop].aantal
	end
	screen.waitVblankStart()
	screen.flip()
	startmenu=kop*100+regel	
	if pad:cross() then
		if startmenu == 101 then credits() end	
		if startmenu == 102 then nbol() end
		if startmenu == 103 then datum() end	
		if startmenu == 104 then System.Quit() end	
		if startmenu == 201 then starv() end
		if startmenu == 202 then constelationv() end
		if startmenu == 203 then messierv() end
		if startmenu == 301 then plot()	starchart() end	
		if startmenu == 302 then skychart() end	
	end
	for a=1,40000 do end	-- slow down menu
	menu()
end 